App/App/Areas/Admin/Controllers/UserController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using App.Class;
using DataAccess.Dao;
using DataAccess.Model;

namespace App.Areas.Admin.Controllers
{
    [Authorize(Roles = Role.Admin)]
    public class UserController : Controller
    {
        // GET: Admin/User
        public ActionResult UsersCategories(int id, int? page) //hlavní stránka s uživetli a stránkováním 
        {
            int itemsOnPage = 5;
            int pg = page.HasValue ? page.Value : 1;
            int totalUsers;

            IList<VyukaUser> users = new VyukaUserDao().GetUsersByCategoryPaged(id, itemsOnPage, pg, out totalUsers);
            ViewBag.Categories = new VyukaRoleDao().GetAll(); //zobtazení uživatelů podle jejich role (admin nebo uživatel)

            ViewBag.Pages = (int)Math.Ceiling((double)totalUsers / (double)itemsOnPage);
            ViewBag.CurrentPage = pg;

            if (Request.IsAjaxRequest())
            {
                return PartialView("IndexList", users);
            }
            return View("IndexList", users);
        }

        public ActionResult ChangeUserRole(int userId, int roleId)
        {
            VyukaUserDao userDao = new VyukaUserDao();
            VyukaUser user = userDao.GetById(userId); //načtení uživatele
            VyukaRoleDao roleDao = new VyukaRoleDao();
            user.Role = roleDao.GetById(roleId); //načtení jeho role 
            userDao.Update(user);
                
            int itemsOnPage = 5;
            int totalUsers;

            IList<VyukaUser> users = userDao.GetUsersByCategoryPaged(roleId, itemsOnPage, 1, out totalUsers); //stránkování podle rolí 
            ViewBag.Categories = roleDao.GetAll();

            ViewBag.Pages = (int)Math.Ceiling((double)totalUsers / (double)itemsOnPage);
            ViewBag.CurrentPage = 1;

            if (Request.IsAjaxRequest())
            {
                return PartialView("IndexList", users);
            }
            return View("IndexList", users);
        }

        public ActionResult DetailUser(int id)
        {
            VyukaUserDao vyukaUserDao = new VyukaUserDao();
            VyukaUser u = vyukaUserDao.GetById(id); //zobrazení detailů o uživateli 

            if (Request.IsAjaxRequest())
            {
                return PartialView(u);
            }
            return View(u);
        }

        public ActionResult SearchU(string phrase)
        {
            VyukaUserDao vyukaUserDao = new VyukaUserDao();
            ViewBag.Categories = new VyukaRoleDao().GetAll();
            IList<VyukaUser> users = vyukaUserDao.SearchUser(phrase);

            if (Request.IsAjaxRequest())
            {
                return PartialView("IndexList", users);
            }
            return View("IndexList", users);
        }

        public JsonResult SearchUser(string query)
        {
            VyukaUserDao vyukaUserDao = new VyukaUserDao();
            IList<VyukaUser> users = vyukaUserDao.SearchUser(query);

            List<string> names = (from VyukaUser a in users select a.Login).ToList();

            return Json(names, JsonRequestBehavior.AllowGet);
        }
    }
}

App/App/Areas/User/Controllers/HomeController.cs
using System.Web.Mvc;
using App.Class;

namespace App.Areas.User.Controllers
{
    [Authorize(Roles = Role.User)]
    public class HomeController : Controller
    {
        // GET: User/Home
        public ActionResult IndexUser()
        {
            if (Request.IsAjaxRequest())
            {
                return PartialView();
            }
            return View();
        }

        public ActionResult KnowProfile()
        {
            if (Request.IsAjaxRequest())
            {
                return PartialView();
            }
            return View();
        }

        public ActionResult KnowText()
        {
            if (Request.IsAjaxRequest())
            {
                return PartialView();
            }
            return View();
        }

        public ActionResult KnowVocabulary()
        {
            if (Request.IsAjaxRequest())
            {
                return PartialView();
            }
            return View();
        }

        public ActionResult KnowMessage()
        {
            if (Request.IsAjaxRequest())
            {
                return PartialView();
            }
            return View();
        }
    }
}

App/App/Areas/User/Controllers/MenuController.cs
using System.Web.Mvc;
using App.Class;
using DataAccess.Dao;

namespace App.Areas.User.Controllers
{
    [ChildActionOnly]
    [Authorize(Roles = Role.User)]
    public class MenuController : Controller
    {
        // GET: User/Menu
        public ActionResult Index()
        {
            var vyukaUserDao = new VyukaUserDao();
            var vyukaUser = vyukaUserDao.GetByLogin(User.Identity.Name);
            return View("UserMenu", vyukaUser);
        }

        public ActionResult SidemenuProfil()
        {
            return PartialView();
        }

        public ActionResult SidemenuVocabulary()
        {
            return PartialView();
        }

        public ActionResult SidemenuText()
        {
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            return PartialView();
        }

        public ActionResult SidemenuTest()
        {
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            return PartialView();
        }

        public ActionResult SidemenuTestStart()
        {
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            return PartialView();
        }

        public ActionResult SidemenuTestSubmit()
        {
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            return PartialView();
        }

        public ActionResult SidemenuHome()
        {
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            return PartialView();
        }

        public ActionResult SidemenuMessage()
        {
            return PartialView();
        }
    }
}

App/App/Areas/User/Controllers/MessageController.cs
using System.Web.Mvc;
using App.Class;
using DataAccess.Dao;
using DataAccess.Model;

namespace App.Areas.User.Controllers
{
    [Authorize(Roles = Role.User)]
    public class MessageController : Controller
    {
        // GET: User/Text
        public ActionResult Index()
        {
            Message message = new Message()
            {
                //nalezení jména (přezdívky) uživatele, který píše zprávu
                UserName = User.Identity.Name
            };
           
            if (Request.IsAjaxRequest())
            {
                return PartialView(message);
            }
            return View(message);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult SendMessage(Message message)
        {
            if (ModelState.IsValid)
            {
                new MessageDao().Create(message);
                TempData["message-success"] = "Vaše zpárva byla úspěšně odeslána.";
                message = new Message()
                {
                    UserName = User.Identity.Name,
                    Sender = "",
                    Subject = "",
                    Text = ""
                };
                return RedirectToAction("Index", message);
            }
        
            if (Request.IsAjaxRequest())
                {
                    return PartialView("Index",message);
                }           
            return View("Index",message);
        }
    }
}

App/App/Areas/User/Controllers/ProfilController.cs
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.WebPages;
using App.Areas.User.Class;
using App.Class;
using App.Models;
using DataAccess.Dao;
using DataAccess.Model;

namespace App.Areas.User.Controllers
{
    [Authorize(Roles = Role.User)]
    public class ProfilController : Controller
    {
        // GET: User/Profil
        public ActionResult EditProfil()
        {
            VyukaUserDao vyukaUserDao = new VyukaUserDao();
            VyukaUser user = vyukaUserDao.GetByLogin(User.Identity.Name);

            if (Request.IsAjaxRequest())
            {
                return PartialView(user);
            }
            return View(user);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Update(VyukaUser user, HttpPostedFileBase picture)
        {
            if (ModelState.IsValid)
            {
                VyukaUserDao vyukaUserDao = new VyukaUserDao();

                if (picture != null)
                {
                    //nahrávané obrázky mohou být .jpg nebop .png
                    if (picture.ContentType == "image/jpeg" || picture.ContentType == "image/png")
                    {
                        Image image = Image.FromStream(picture.InputStream);

                        //jedinečný identifikátor
                        Guid guid = Guid.NewGuid();
                        string imageName = guid + ".jpg";

                        //pokud je velikost obrázku větší než 1000x1000px, zmenší se jeho velikos na maximální 1000x1000px
                        if (image.Height > 1000 || image.Width > 1000)
                        {
                            Image smallImage = ImageHelper.ScaleImage(image, 1000, 1000);
                            //vytvoření v rastrové grafice 
                            Bitmap b = new Bitmap(smallImage);

                            //uložení obrázku s jeho jedinečným identifikátorem do dbs ve formátu .jpg
                            b.Save(Server.MapPath("~/uploads/profilePictures/" + imageName), ImageFormat.Jpeg);

                            //uvolnení prostředků
                            smallImage.Dispose();
                            b.Dispose();
                        }
                        else
                        {
                            picture.SaveAs(Server.MapPath("~/uploads/profilePictures/" + imageName));
                        }

                        //přemazání aktuálního profilového obrázku 
                        if (!user.Image.IsEmpty())
                        {
                            System.IO.File.Delete(Server.MapPath("~/uploads/profilePictures/" + user.Image));
                        }
                        user.Image = imageName;
                    }
                }
                vyukaUserDao.Update(user);
                TempData["message-success"] = "Údaje uživatele " + user.Login + " byly upraveny";
            }
            return RedirectToAction("Profil");
        }

        public ActionResult Profil()
        {
            var vyukaUserDao = new VyukaUserDao();
            var user = vyukaUserDao.GetByLogin(User.Identity.Name);

            if (Request.IsAjaxRequest())
            {
                return PartialView(user);
            }

            return View(user);
        }

        public ActionResult Password()
        {

            ViewBag.Login = User.Identity.Name;
            if (Request.IsAjaxRequest())
            {
                return PartialView();
            }
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult ChangePassword(UserChangePassword user)
        {
            //ověření loginu a jeho hesla s jeho heshovanou podobou
            if (new VyukaUserDao().GetByLoginAndPassword(user.Login, user.CurrPass.HashPassword()) != null)
            {
                if (ModelState.IsValid)
                {
                    var vyukaUserDao = new VyukaUserDao();
                    var vyukaUser = vyukaUserDao.GetByLogin(user.Login);

                    vyukaUser.Password = user.NewPass.HashPassword();
                    vyukaUserDao.Update(vyukaUser);

                    TempData["message-success"] = "Heslo uživatele " + user.Login + " bylo upraveno";
                }

                if (Request.IsAjaxRequest()) return PartialView("Password");
                return View("Password");
            }

            ModelState.AddModelError("CurrPass",
                "Heslo uživatele " + user.Login + " bylo zadáno nesprávně, zkusteto znovu.");

            if (Request.IsAjaxRequest()) return PartialView("Password");

            return View("Password");
        }

        public ActionResult FinishedTestList(int? page)
        {
            int itemsOnPage = 10;
            int pg = page.HasValue ? page.Value : 1;

            TestFinishedDao testFinishedDao = new TestFinishedDao();
            //načtení ukončených testů konkrétního uživatele a jejich případné rozstránkování 
            IList<TestFinished> tests = testFinishedDao.GetTestListByUserAndPage(new VyukaUserDao().GetByLogin(User.Identity.Name).Id, itemsOnPage, pg, out var totalWords);

            ViewBag.Pages = (int)Math.Ceiling((double)totalWords / (double)itemsOnPage);
            ViewBag.CurrentPage = pg;

            IList<TestName> testNames = new List<TestName>();
            ArticleDao articleDao = new ArticleDao();
            //přiřazení jména článku ke každému ukončenému testu
            foreach (TestFinished test in tests)
            {
                testNames.Add(new TestName
                {
                    TestFinished = test,
                    Article = articleDao.GetArticleByTestId(test.TestId)
                });
            }

            if (Request.IsAjaxRequest())
            {
                return PartialView(testNames);
            }
            return View(testNames);
        }
    }
}

App/App/Areas/User/Controllers/TestController.cs
using System;
using System.Web.Mvc;
using App.Class;
using DataAccess.Dao;
using DataAccess.Model;

namespace App.Areas.User.Controllers
{
    [Authorize(Roles = Role.User)]

public class TestController : Controller
    {
        // GET: User/Test
        public ActionResult Index(int id)
        {
            //načtení testu podle jeho Id
            Test test = new TestDao().GetById(id);
            //zobrazení dokončených testů konkrétního uživatele
            ViewBag.TestList =
                new TestFinishedDao().GetTestListByUserIdAndTestId(new VyukaUserDao().GetByLogin(User.Identity.Name).Id,
                    id);
            if (Request.IsAjaxRequest())
            {
                return PartialView(test);
            }
            return View(test);
        }

        public ActionResult StartTest(int id)
        {
            Test test = new TestDao().GetById(id);

            ViewBag.Nazev = new ArticleDao().GetArticleByTestId(id).Name;
            foreach (TestQuestions question in test.Questions)
            {
                foreach (TestAnswer answer in question.Answers)
                {
                    answer.IsCorrect = false;
                }
            }
            if (Request.IsAjaxRequest())
            {
                return PartialView(test);
            }
            return View(test);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult SubmitTest(Test testFilled)
        {
            //přiřazení id vyplněného testu 
            Test test = new TestDao().GetById(testFilled.Id);

            byte score = 0;
            byte maxScore = 0;

            for (int i = 0; i < test.Questions.Count; i++)
            {
                for (int j = 0; j < test.Questions[i].Answers.Count; j++)
                {
                    //ověření zda byla vyplněná odpověď správná
                    bool filledAnswer = testFilled.Questions[i].Answers[j].IsCorrect;
                    //ověření zda je testová otázka označená jako správná 
                    bool testAnswer = test.Questions[i].Answers[j].IsCorrect;
                    //ověření zda byla vybrána správná nebo špatná odpověď odpověď 
                    testFilled.Questions[i].Answers[j].WasCorrect = filledAnswer == testAnswer;

                    if (testAnswer && filledAnswer)
                    {
                        score++;
                    }
                    if(testAnswer)
                    {
                        maxScore++;
                    }
                }
            }

            ViewBag.Score = score;
            ViewBag.MaxScore = maxScore;
            ViewBag.Nazev = new ArticleDao().GetArticleByTestId(test.Id).Name;

            //vytvoření ukončeného testu podle uživatele
            new TestFinishedDao().Create(new TestFinished()
            {
                CompletingTest = DateTime.Now,
                MaxScore = maxScore,
                Score = score,
                TestId = test.Id,
                UserId = new VyukaUserDao().GetByLogin(User.Identity.Name).Id
            });

            if (Request.IsAjaxRequest())
            {
                return PartialView(testFilled);
            }
            return View(testFilled);
        }
    }
}

App/App/Areas/Admin/Views/User/DetailUser.cshtml
﻿@model DataAccess.Model.VyukaUser

<div class="container-fluid dashboard-content">
    <h2>Uživatel @Model.Login</h2>
    <p>
        Jméno: @Model.Name @Model.Surname
    </p>
    <p>
        @if (!string.IsNullOrEmpty(Model.Image))
        {
            <img src="@Url.Content("~/uploads/profilePictures/" + Model.Image)" class="img-fluid" alt="Responsive image" />
        }
    </p>
    <p>
        Datum narození: @(@Model.Birth.HasValue ? Model.Birth.Value.ToShortDateString() : "Neuvedeno")
    </p>
    <p>
        Datum registrace:  @Model.RegistrationDay.ToShortDateString()
    </p>
    <p>
        Datum posledního přihlášení: @Model.LastActivityDay.ToShortDateString()
    </p>
</div>

App/App/Areas/Admin/Views/User/IndexList.cshtml
@using DataAccess.Model
@model IList<DataAccess.Model.VyukaUser>

@{Html.RenderAction("SidemenuList", "Menu");}

<div class="dashboard-wrapper">
    <div class="container-fluid dashboard-content">
        @if (TempData["message-success"] != null)
        {
            <div class="alert alert-success alert-dismissible" role="alert">
                <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">x</span></button>
                @TempData["message-success"]
            </div>
        }
        <div class="form-inline mt-2 mt-md-0">
            @using (Ajax.BeginForm("SearchU", new AjaxOptions() { UpdateTargetId = "dynamicContent", InsertionMode = InsertionMode.Replace }))
            {
                <input class="form-control mr-sm-2" type="text" placeholder="Vyhledávání" aria-label="Vyhledejte frázi" id="searchBox" name="phrase">
                <button class="btn btn-outline-success my-2 my-sm-0" type="submit" style="margin-right: 15px">Vyhledat</button>
            }
        </div>
        <label for="submit-button"></label>

        <div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLabel">Detail uživatele</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body" id="modalContent">
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Zavřít</button>
                    </div>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-9">
                <table class="table">
                    <thead class="thead-dark">
                        <tr>
                            <th scope="col">Uživatel</th>
                            <th scope="col">Akce</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach (VyukaUser u in Model)
                        {
                            <tr>
                                <td>@Ajax.ActionLink(u.Login, "DetailUser", new { id = u.Id }, new AjaxOptions() { UpdateTargetId = "modalContent", InsertionMode = InsertionMode.Replace, OnBegin = "openModalWindow" })</td>
                                @if (u.Role.Id == 1)
                                {
                                    <td>@Html.ActionLink("Zrušit oprávnění", "ChangeUserRole", "User", new { userId = u.Id, roleId = 2 }, new { onclick = "return confirm('Přejete si opravdu zrušit orpávnění uživatele " + u.Login + " ?');" })</td>
                                }
                                else
                                {
                                    <td>@Html.ActionLink("Jmenovat administrátorem", "ChangeUserRole", "User", new { userId = u.Id, roleId = 1 }, new { onclick = "return confirm('Přejete si opravdu jmenovat administrátorem uživatele " + u.Login + " ?');" })</td>
                                }
                            </tr>
                        }
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    @if (ViewBag.Pages > 1)
    {
        <ul class="pagination mt-2">
            @for (int i = 1; i <= ViewBag.Pages; i++)
            {
                <li class=@(ViewBag.CurrentPage == i ? "active" : "")>
                    @Ajax.ActionLink(i.ToString(), "UsersCategories", new { page = i }, new AjaxOptions() { InsertionMode = InsertionMode.Replace, UpdateTargetId = "dynamicContent" }, new { @class = "page-link" })
                </li>
            }
        </ul>
    }
</div>

<script type="text/javascript">
    function openModalWindow() {
        $('#myModal').modal({
            show: true
        });
    }

    $(function () {
            $("#searchBox").autocomplete({
                source: function (request, response) {
                    $.ajax({
                        url:'@Url.Action("SearchUser", "User")',
                    dataType: "json",
                    data: {
                        query: request.term
                    },
                    success: function (data) {
                        response(data);
                    }
                });
            },
            minLength: 2
        });
    });
</script>